<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>You are Here</title>
    <link rel="stylesheet" href="main.css">
</head>
<body>
<div class="imageWrapper">
    <img id="main_map" class="overlayImage" src="2022_map.jpg" alt="map of UL" onload="main()">
    <img id="marker" class="overlayImage" src="marker.png" alt="marker" >

</div>
<script>

    function main(){
        let map = img_size()

        // can now handle the parameters
        let id = get_id();
        if(isNaN(id)){
            return;
        }

        let position = get_position(id);
        if(!position){
            return;
        }

        move_marker(map, position);
    }

    function img_size(){
        // get the screen
        const width_device = (window.innerWidth > 0) ? window.innerWidth : screen.width;

        // get the image
        const img = document.getElementById('main_map');
        let width_img = img.clientWidth;
        let height_img = img.clientHeight;

        // resize the img
        let scale = width_img/width_device;

        img.width  = width_img / scale;
        img.height = height_img / scale;

        return {
            width_original: width_img, height_original: height_img,
            width_now: img.width, height_now: img.height,
            scale: scale
        }
    }

    function get_id(){
        // from https://stackoverflow.com/a/901144/11964934

        const params = new Proxy(new URLSearchParams(window.location.search), {
            get: (searchParams, prop) => searchParams.get(prop),
        });

        // return early
        if(!params["id"]){
            return;
        }

        return parseInt(params["id"], 10);
    }

    function get_position(id){
        // time to get its location
        let positions = {
            // [vertical, horizontal]

            // Health science
            1: [0.52,0.56],
            // CSIS
            2: [0.56,0.38],
            // Student Life
            3: [0.6,0.5],
        }

        return positions[id];
    }

    function move_marker(map, position){
        const img = document.getElementById('marker');


        let width_img = img.clientWidth;
        let height_img = img.clientHeight;

        let marker_scale = 5;

        img.width  = (width_img / map.scale) * marker_scale;
        img.height = (height_img / map.scale) * marker_scale;


        img.style.position = 'absolute';
        let height_offset = (map.height_now * position[0]) - img.height;
        let width_offset = (map.width_now * position[1]) - (img.width/2);

        img.style.top = `${height_offset}px`;
        img.style.left = `${width_offset}px`;


        //let scale = 2.5;
        // zoom into that location
        //document.body.style.transform = `translate(${map.width_now }px)`;

        setTimeout( () => {
            window.scroll(width_offset, height_offset);
        },100);


    }
</script>
</body>
</html>